from random import randrange


class BinarySearchTree:
    def __init__(self, key):
        self.key = key
        self.left = None
        self.right = None

    def insert(self, key):
        if key <= self.key:
            if self.left is not None:
                self.left.insert(key)
            else:
                self.left = BinarySearchTree(key)
        else:
            if self.right:
                self.right.insert(key)
            else:
                self.right = BinarySearchTree(key)

    def search(self, key):
        if self.key == key:
            return True
        if key < self.key:
            if not self.left:
                return False
            return self.left.search(key)
        if not self.right:
            return False
        return self.right.search(key)

    def __str__(self):
        return f"[{self.key}; {self.left}; {self.right}]"

    def inorder(self):
        if self.left:
            self.left.inorder()

        print(self.key)

        if self.right:
            self.right.inorder()

    def preorder(self):
        print(self.key)

        if self.left:
            self.left.preorder()
        if self.right:
            self.right.preorder()

    def postorder(self):
        if self.left:
            self.left.postorder()
        if self.right:
            self.right.postorder()

        print(self.key)


def main():
    r = BinarySearchTree(0)
    # lst = (randrange(-50, 50) for _ in range(20))
    lst = [26, -27, 6, -33, -6, -34, -21, 48, -31, 49,
           0, -35, -22, 49, 21, -30, -18, 48, 28, 0, 14]
    for x in lst:
        r.insert(x)

    print(r)
    print(r.search(14))
    print(r.search(-7))
    r.inorder()



if __name__ == "__main__":
    main()
