class Stack:
    def __init__(self):
        self.items = []

    # O(1)
    def is_empty(self):
        return self.items == []

    # O(1)
    def push(self, item):
        self.items.append(item)

    # O(1)
    def pop(self):
        return self.items.pop()

    # O(1)
    def peek(self):
        return self.items[-1]

    # O(1)
    def size(self):
        return len(self.items)


# alternatywna implementacja stosu
class Stack1:
    def __init__(self):
        self.items = []

    # O(1)
    def is_empty(self):
        return self.items == []

    # O(n)
    def push(self, item):
        self.items.insert(0, item)

    # O(n)
    def pop(self):
        return self.items.pop(0)

    # O(1)
    def peek(self):
        return self.items[0]

    # O(1)
    def size(self):
        return len(self.items)
